//
//  SyncedNote.swift
//  cviko-tv
//
//  Created by Martin Hruby on 18.04.18.
//  Copyright © 2018 Martin Hruby. All rights reserved.
//

import Foundation
import CloudKit
import CoreData

//
extension SyncedNote {
    //
    class func FRCFetchRequest() -> NSFetchRequest<SyncedNote> {
        //
        let _fr = NSFetchRequest<SyncedNote>(entityName: "SyncedNote")
        
        //
        _fr.sortDescriptors = [NSSortDescriptor(key: "text", ascending: true)]
        
        //
        return _fr
    }
    
    //
    class func newNote(txt: String) -> SyncedNote {
        //
        let _nn = NSEntityDescription.insertNewObject(forEntityName: "SyncedNote", into: DataMAN.shared.MOC) as! SyncedNote
        
        //
        _nn.text = txt
        _nn.created = Date()
        
        //
        return _nn
    }
    
    //
    class func updateFromCK(ck:CKRecord) {
        //
        let _rname = ck.recordID.recordName
        
        //
        let _req = NSFetchRequest<SyncedNote>(entityName: "SyncedNote")
        _req.predicate = NSPredicate(format: "ckrecordname=%@", _rname)
        
        //
        if let _res = try? DataMAN.shared.MOC.fetch(_req), let _it = _res.first {
            // existuje lokalne, update
            _it.updateFromCK(ck: ck)
        } else {
            // neexistuje lokalne, insert
            let _n = newNote(txt: "")
            
            //
            _n.updateFromCK(ck: ck)
        }
    }
    
    //
    class func updateFromCK(deleted ckID:CKRecordID) {
        //
        let _rname = ckID.recordName
        
        //
        let _req = NSFetchRequest<SyncedNote>(entityName: "SyncedNote")
        _req.predicate = NSPredicate(format: "ckrecordname=%@", _rname)
        
        // mam ho lokalne, pak smazat lokalne
        if let _res = try? DataMAN.shared.MOC.fetch(_req), let _it = _res.first {
            // existuje lokalne, update
            //
            DataMAN.shared.MOC.delete(_it)
        } else {
            // neexistuje lokalne, insert
            // tudiz ignore
        }
    }
    
    //
    func updateFromCK(ck:CKRecord) {
        //
        self.text = (ck["text"] as? String) ?? nil
        
        //
        self.ckencoded = ck.__primEncode()
        self.ckmodified = false
        self.ckrecordname = ck.recordID.recordName
        
        //
        if let _docAsset = ck["document"] as? CKAsset {
            //
            self.document = try? Data(contentsOf: _docAsset.fileURL)
        }
    }
    
    //
    func yourCK() -> CKRecord? {
        //
        guard let _ck = generateCK() else {
            //
            return nil
        }
        
        //
        _ck["text"] = (self.text ?? "notext") as CKRecordValue
        
        //
        if let _pic = document {
            // dejme tomu nejake TMP jmeno
            let __tmpName = NSUUID().uuidString + ".json"
            let _tmps = FileManager.default.temporaryDirectory
            
            // toto bude url pro CKAsset
            let assetURL = _tmps.appendingPathComponent(__tmpName)
            
            // zapsani do app:sandboxTMP
            do { try _pic.write(to: assetURL)} catch { return nil }
            
            // instanciace
            _ck["document"] = CKAsset(fileURL: assetURL)
        }
        
        //
        return _ck
    }
}
