//
//  ViewController.swift
//  cviko-tv
//
//  Created by Martin Hruby on 17.04.18.
//  Copyright © 2018 Martin Hruby. All rights reserved.
//

import UIKit

//
class NoteTableCell: UITableViewCell {
    //
    @IBOutlet weak var noteText: UILabel!
    @IBOutlet weak var pic: UIImageView!
}

//
class NoteVC: UITableViewController {
    //
    var FRCDataSource: FRCTableDataSource<SyncedNote>!
    
    //
    lazy var demopic: UIImage = {
        //
        return UIImage(named: "demopic.png")!
    }()
    
    //
    @objc func addNote(_:AnyObject) {
        //
        let nn = SyncedNote.newNote(txt: "nejakyText")
        
        //
        nn.ckmodified = true
    }
    
    @objc func modif(_:AnyObject) {
        //
        if let _sel = tableView.indexPathsForSelectedRows?.first {
            //
            if let _hehe = FRCDataSource.FRC.object(at: _sel) as? SyncedNote {
                //
                _hehe.text = "modif\(Date())"
                _hehe.ckmodified = true
            }
        }
    }
    
    // restart synchronizace lokalu a cloudu
    @objc func doreset(_:AnyObject) {
        // zrusim token
        UserDefaults.standard.serverChangeToken = nil
        
        // vsechny lokalni data smazu
        if let _allr = SyncedNote.allRecords(entityName: "SyncedNote", modifOnly: false) {
            //
            let _moc = DataMAN.shared.MOC
            
            //
            _allr.forEach {
                //
                _moc.delete($0)
            }
            
            //
            DataMAN.shared.localSAVE()
        }
        
        // volam fetch
        DispatchQueue.global().async {
            //
            DataMAN.shared.doDiffFetches { }
        }
    }
    
    @objc func localSave(_:AnyObject) {
        //
        DataMAN.shared.APP.saveContext()
    }
    
    //
    @objc func diffFetch(_:AnyObject){
        //
        DataMAN.shared.doDiffFetches {}
    }
    
    //
    @objc func addPIC(_:AnyObject){
        //
        if let _sel = tableView.indexPathsForSelectedRows?.first {
            //
            if let _hehe = FRCDataSource.FRC.object(at: _sel) as? SyncedNote {
                //
                _hehe.document = UIImagePNGRepresentation(demopic)
                _hehe.ckmodified = true
                
                //
                print("K bunce/zaznamu pridan obrazek")
            }
        }
    }
    
    //
    @objc func exportSavesToCloud(_:AnyObject){
        //
        DataMAN.shared.fetchAndSyncModifiedToCloud()
    }
    
    
    //
    func cfgCell(note:SyncedNote, cell:UITableViewCell) {
        //
        if let _cell = cell as? NoteTableCell {
            //
            _cell.noteText.text = note.text ?? "ee"
            
            //
            if let _add = note.document {
                //
                _cell.pic.image = UIImage(data: _add)
            } else {
                // !!!! explicitne nulovat,
                // bunka je znovupouzitelna
                _cell.pic.image = nil
            }
        }
    }

    //
    override func viewDidLoad() {
        //
        super.viewDidLoad()
        
        //
        let _ = DataMAN.shared.APP
        let _ = DataMAN.shared.MOC
        
        //
        FRCDataSource = FRCTableDataSource<SyncedNote>(withRQ: SyncedNote.FRCFetchRequest(), cellID: "noteCell", tableView: self.tableView, cfg: cfgCell)
        
        //
        let _addBut = UIBarButtonItem(barButtonSystemItem: .add, target: self, action: #selector(addNote(_:)))
        //
        let _modif = UIBarButtonItem(title: "modif", style: .plain, target: self, action: #selector(modif(_:)))
        //
        let _diffFetch = UIBarButtonItem(title: "dFetch", style: .plain, target: self, action: #selector(diffFetch(_:)))
        
        //
        let _reset = UIBarButtonItem(title: "reset", style: .plain, target: self, action: #selector(doreset(_:)))
        
        //
        let _save = UIBarButtonItem(title: "lsave", style: .plain, target: self, action: #selector(localSave(_:)))
        let _cloudsave = UIBarButtonItem(title: "CKsave", style: .plain, target: self, action: #selector(exportSavesToCloud(_:)))
        
        let _pic = UIBarButtonItem(title: "pic", style: .plain, target: self, action: #selector(addPIC(_:)))
        
        //
        self.navigationItem.rightBarButtonItems = [_pic, _reset, _diffFetch, _modif, _addBut]
        self.navigationItem.leftBarButtonItems = [_save, _cloudsave]
        
        //
        if FRCDataSource.startup() {
            //
            self.tableView.dataSource = FRCDataSource
            //
            self.tableView.reloadData()
        }
    }
}

