//
//  dataManagement-MOC.swift
//  cviko-tv
//
//  Created by Martin Hruby on 17.04.18.
//  Copyright © 2018 Martin Hruby. All rights reserved.
//

import Foundation
import CloudKit
import CoreData


//
extension Array where Element == SyncedNote {
    //
    func yourCKs() -> [CKRecord:SyncedNote] {
        //
        var cks = [CKRecord:SyncedNote]()
        
        for i in self {
            //
            if let _ck = i.yourCK() {
                //
                cks[_ck] = i
            }
        }
        
        //
        return cks
    }
}

//
extension DataMAN {
    //
    @objc func mocEvent(_ notif:Notification) {
        //
        guard let _info = notif.userInfo else { return }
        
        //
        var _toSaveMO = Set<SyncedNote>()
        
        //
        if let _inserts = _info[NSInsertedObjectsKey] as? Set<SyncedNote> {
            //
            _toSaveMO = _toSaveMO.union(_inserts)
        }
        
        //
        if let _updates = _info[NSUpdatedObjectsKey] as? Set<SyncedNote> {
            //
            _toSaveMO = _toSaveMO.union(_updates)
        }
        
        //
        let __toSaveMO = [SyncedNote](_toSaveMO)
        let toSave = __toSaveMO.yourCKs()
        let toSaveCKs = [CKRecord](toSave.keys)
        
        /*
        if let _dels = _info[NSDeletedObjectsKey] as? Set<SyncedNote> {
            //
            toDel.append(contentsOf: _dels.asArray().yourCKs().map { $0.recordID })
        }*/

        //
        let _op = CKModifyRecordsOperation(recordsToSave: toSaveCKs,
                                           recordIDsToDelete: [])
        
        //
        _op.modifyRecordsCompletionBlock = { saved, _, error in
            //
            print("Save to CK: \(error)")
            
            //
            if let _saved = saved {
                //
                for c in _saved {
                    //
                    if let _rec = toSave[c] {
                        //
                        _rec.wasSyncedToCloud(withCKRecord: c)
                    }
                }
            }
        }
        
        //
        ckDB.add(_op)
    }
}
