//
//  ViewController.swift
//  natelku2
//
//  Created by Martin Hruby on 18.04.18.
//  Copyright © 2018 Martin Hruby. All rights reserved.
//

import UIKit
import CloudKit

class DetailView: UIViewController {
    //
    var det: CKRecord? = nil
    @IBOutlet var pic: UIImageView!
    
    @objc func back(_:AnyObject) {
        //
        self.navigationController?.popViewController(animated: true)
    }
    
    //
    override func viewDidLoad() {
        //
        super.viewDidLoad()
        
        if
            let _det = det,
            let _doc = _det["document"] as? CKAsset,
            let _data = UIImage(contentsOfFile: _doc.fileURL.path) {
                //
                pic.image = _data
        }
        
        //
        let _back = UIBarButtonItem(title: "Back", style: .plain,
                                    target: self, action: #selector(back(_:)))
        
        //
        self.navigationItem.leftBarButtonItem = _back
    }
}

class TelkaTabulka: UITableViewController {
    //
    let ck = CKContainer(identifier: "iCloud.eu.cdplan-solutions.cviko-tv")
    let db = CKContainer(identifier: "iCloud.eu.cdplan-solutions.cviko-tv").privateCloudDatabase
    
    //
    var _loada: UIBarButtonItem!
    
    
    //
    var them: [CKRecord] = []
    
    //
    func loadEmAll() {
        //
        them = []
        
        //
        let _ckq = CKQuery(recordType: "SyncedNote",
                           predicate: NSPredicate(value: true))
        
        //
        let _ck = CKQueryOperation(query: _ckq)
        
        //
        _ck.recordFetchedBlock = { (ckr:CKRecord) in
            //
            print("Mam \(ckr.recordID.recordName)")
            
            //
            self.them.append(ckr)
        }
        
        //
        _ck.queryCompletionBlock = { _, error in
            //
            print("Error \(error)")
            
            //
            if error == nil {
                //
                DispatchQueue.main.async {
                    //
                    self.tableView.reloadData()
                }
            }
        }
        
        //
        db.add(_ck)
    }
    
    @objc func fullLoad(_:AnyObject) {
        //
        loadEmAll()
    }
    
    //
    override func numberOfSections(in tableView: UITableView) -> Int {
        //
        return 1
    }
    
    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        //
        return them.count
    }
    
    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        //
        let _cella = tableView.dequeueReusableCell(withIdentifier: "syncedNote", for: indexPath)
        
        //
        let _ck = them[indexPath.row]
        let _text = (_ck["text"] as? String) ?? "nictuneni"
        
        //
        _cella.textLabel?.text = _text
        
        //
        return _cella
    }
    
    override func prepare(for segue: UIStoryboardSegue, sender: Any?)
    {
        guard
            let _ckrIDX = tableView.indexPathForSelectedRow
            else {
                //
                return
            }
        
        //
        if let _dest = segue.destination as? DetailView {
            //
            _dest.det = them[_ckrIDX.row]
        }
    }

    //
    override func viewDidLoad() {
        //
        super.viewDidLoad()
        
        _loada = UIBarButtonItem(title: "sync", style: .plain,
                                 target: self, action: #selector(fullLoad(_:)))
        
        //
        self.navigationItem.rightBarButtonItems = [_loada]
        
        //
        DispatchQueue.global().async {
            //
            self.loadEmAll()
        }
    }
}

